import "./form-datepicker.css";
import { defineComponent as Ce, resolveComponent as ce, openBlock as m, createBlock as L, Teleport as Ye, createElementBlock as k, normalizeClass as G, normalizeStyle as ge, Fragment as j, renderList as K, withModifiers as w, toDisplayString as F, createCommentVNode as I, createElementVNode as D, resolveDynamicComponent as N, withCtx as fe, createTextVNode as Le, mergeProps as pe, createVNode as ve, createSlots as qe } from "vue";
import { c as ae, a as se } from "../../_commonjsHelpers-aeeeeb92.js";
import He from "../form-input/form-input.js";
import Fe from "../button/button.js";
import { g as Ve, h as ke, j as Ie, k as Ae, a as Ne, f as _e, b as We, l as je, x as Pe } from "../../icons-fca12ed8.js";
import { r as $e } from "../../helper-4d4ed314.js";
import { _ as De } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
var de = { exports: {} }, Se;
function Me() {
  return Se || (Se = 1, function(e, t) {
    (function(n, i) {
      e.exports = i();
    })(ae, function() {
      var n = 1e3, i = 6e4, l = 36e5, g = "millisecond", $ = "second", s = "minute", y = "hour", v = "day", z = "week", h = "month", C = "quarter", q = "year", _ = "date", Z = "Invalid Date", B = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, oe = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, le = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), ordinal: function(p) {
        var o = ["th", "st", "nd", "rd"], r = p % 100;
        return "[" + p + (o[(r - 20) % 10] || o[r] || o[0]) + "]";
      } }, E = function(p, o, r) {
        var u = String(p);
        return !u || u.length >= o ? p : "" + Array(o + 1 - u.length).join(r) + p;
      }, ue = { s: E, z: function(p) {
        var o = -p.utcOffset(), r = Math.abs(o), u = Math.floor(r / 60), a = r % 60;
        return (o <= 0 ? "+" : "-") + E(u, 2, "0") + ":" + E(a, 2, "0");
      }, m: function p(o, r) {
        if (o.date() < r.date())
          return -p(r, o);
        var u = 12 * (r.year() - o.year()) + (r.month() - o.month()), a = o.clone().add(u, h), d = r - a < 0, c = o.clone().add(u + (d ? -1 : 1), h);
        return +(-(u + (r - a) / (d ? a - c : c - a)) || 0);
      }, a: function(p) {
        return p < 0 ? Math.ceil(p) || 0 : Math.floor(p);
      }, p: function(p) {
        return { M: h, y: q, w: z, d: v, D: _, h: y, m: s, s: $, ms: g, Q: C }[p] || String(p || "").toLowerCase().replace(/s$/, "");
      }, u: function(p) {
        return p === void 0;
      } }, P = "en", W = {};
      W[P] = le;
      var he = function(p) {
        return p instanceof te;
      }, ee = function p(o, r, u) {
        var a;
        if (!o)
          return P;
        if (typeof o == "string") {
          var d = o.toLowerCase();
          W[d] && (a = d), r && (W[d] = r, a = d);
          var c = o.split("-");
          if (!a && c.length > 1)
            return p(c[0]);
        } else {
          var V = o.name;
          W[V] = o, a = V;
        }
        return !u && a && (P = a), a || !u && P;
      }, b = function(p, o) {
        if (he(p))
          return p.clone();
        var r = typeof o == "object" ? o : {};
        return r.date = p, r.args = arguments, new te(r);
      }, S = ue;
      S.l = ee, S.i = he, S.w = function(p, o) {
        return b(p, { locale: o.$L, utc: o.$u, x: o.$x, $offset: o.$offset });
      };
      var te = function() {
        function p(r) {
          this.$L = ee(r.locale, null, !0), this.parse(r);
        }
        var o = p.prototype;
        return o.parse = function(r) {
          this.$d = function(u) {
            var a = u.date, d = u.utc;
            if (a === null)
              return /* @__PURE__ */ new Date(NaN);
            if (S.u(a))
              return /* @__PURE__ */ new Date();
            if (a instanceof Date)
              return new Date(a);
            if (typeof a == "string" && !/Z$/i.test(a)) {
              var c = a.match(B);
              if (c) {
                var V = c[2] - 1 || 0, M = (c[7] || "0").substring(0, 3);
                return d ? new Date(Date.UTC(c[1], V, c[3] || 1, c[4] || 0, c[5] || 0, c[6] || 0, M)) : new Date(c[1], V, c[3] || 1, c[4] || 0, c[5] || 0, c[6] || 0, M);
              }
            }
            return new Date(a);
          }(r), this.$x = r.x || {}, this.init();
        }, o.init = function() {
          var r = this.$d;
          this.$y = r.getFullYear(), this.$M = r.getMonth(), this.$D = r.getDate(), this.$W = r.getDay(), this.$H = r.getHours(), this.$m = r.getMinutes(), this.$s = r.getSeconds(), this.$ms = r.getMilliseconds();
        }, o.$utils = function() {
          return S;
        }, o.isValid = function() {
          return this.$d.toString() !== Z;
        }, o.isSame = function(r, u) {
          var a = b(r);
          return this.startOf(u) <= a && a <= this.endOf(u);
        }, o.isAfter = function(r, u) {
          return b(r) < this.startOf(u);
        }, o.isBefore = function(r, u) {
          return this.endOf(u) < b(r);
        }, o.$g = function(r, u, a) {
          return S.u(r) ? this[u] : this.set(a, r);
        }, o.unix = function() {
          return Math.floor(this.valueOf() / 1e3);
        }, o.valueOf = function() {
          return this.$d.getTime();
        }, o.startOf = function(r, u) {
          var a = this, d = !!S.u(u) || u, c = S.p(r), V = function(J, Y) {
            var R = S.w(a.$u ? Date.UTC(a.$y, Y, J) : new Date(a.$y, Y, J), a);
            return d ? R : R.endOf(v);
          }, M = function(J, Y) {
            return S.w(a.toDate()[J].apply(a.toDate("s"), (d ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(Y)), a);
          }, T = this.$W, O = this.$M, H = this.$D, Q = "set" + (this.$u ? "UTC" : "");
          switch (c) {
            case q:
              return d ? V(1, 0) : V(31, 11);
            case h:
              return d ? V(1, O) : V(0, O + 1);
            case z:
              var U = this.$locale().weekStart || 0, X = (T < U ? T + 7 : T) - U;
              return V(d ? H - X : H + (6 - X), O);
            case v:
            case _:
              return M(Q + "Hours", 0);
            case y:
              return M(Q + "Minutes", 1);
            case s:
              return M(Q + "Seconds", 2);
            case $:
              return M(Q + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, o.endOf = function(r) {
          return this.startOf(r, !1);
        }, o.$set = function(r, u) {
          var a, d = S.p(r), c = "set" + (this.$u ? "UTC" : ""), V = (a = {}, a[v] = c + "Date", a[_] = c + "Date", a[h] = c + "Month", a[q] = c + "FullYear", a[y] = c + "Hours", a[s] = c + "Minutes", a[$] = c + "Seconds", a[g] = c + "Milliseconds", a)[d], M = d === v ? this.$D + (u - this.$W) : u;
          if (d === h || d === q) {
            var T = this.clone().set(_, 1);
            T.$d[V](M), T.init(), this.$d = T.set(_, Math.min(this.$D, T.daysInMonth())).$d;
          } else
            V && this.$d[V](M);
          return this.init(), this;
        }, o.set = function(r, u) {
          return this.clone().$set(r, u);
        }, o.get = function(r) {
          return this[S.p(r)]();
        }, o.add = function(r, u) {
          var a, d = this;
          r = Number(r);
          var c = S.p(u), V = function(O) {
            var H = b(d);
            return S.w(H.date(H.date() + Math.round(O * r)), d);
          };
          if (c === h)
            return this.set(h, this.$M + r);
          if (c === q)
            return this.set(q, this.$y + r);
          if (c === v)
            return V(1);
          if (c === z)
            return V(7);
          var M = (a = {}, a[s] = i, a[y] = l, a[$] = n, a)[c] || 1, T = this.$d.getTime() + r * M;
          return S.w(T, this);
        }, o.subtract = function(r, u) {
          return this.add(-1 * r, u);
        }, o.format = function(r) {
          var u = this, a = this.$locale();
          if (!this.isValid())
            return a.invalidDate || Z;
          var d = r || "YYYY-MM-DDTHH:mm:ssZ", c = S.z(this), V = this.$H, M = this.$m, T = this.$M, O = a.weekdays, H = a.months, Q = a.meridiem, U = function(Y, R, x, ne) {
            return Y && (Y[R] || Y(u, d)) || x[R].slice(0, ne);
          }, X = function(Y) {
            return S.s(V % 12 || 12, Y, "0");
          }, J = Q || function(Y, R, x) {
            var ne = Y < 12 ? "AM" : "PM";
            return x ? ne.toLowerCase() : ne;
          };
          return d.replace(oe, function(Y, R) {
            return R || function(x) {
              switch (x) {
                case "YY":
                  return String(u.$y).slice(-2);
                case "YYYY":
                  return S.s(u.$y, 4, "0");
                case "M":
                  return T + 1;
                case "MM":
                  return S.s(T + 1, 2, "0");
                case "MMM":
                  return U(a.monthsShort, T, H, 3);
                case "MMMM":
                  return U(H, T);
                case "D":
                  return u.$D;
                case "DD":
                  return S.s(u.$D, 2, "0");
                case "d":
                  return String(u.$W);
                case "dd":
                  return U(a.weekdaysMin, u.$W, O, 2);
                case "ddd":
                  return U(a.weekdaysShort, u.$W, O, 3);
                case "dddd":
                  return O[u.$W];
                case "H":
                  return String(V);
                case "HH":
                  return S.s(V, 2, "0");
                case "h":
                  return X(1);
                case "hh":
                  return X(2);
                case "a":
                  return J(V, M, !0);
                case "A":
                  return J(V, M, !1);
                case "m":
                  return String(M);
                case "mm":
                  return S.s(M, 2, "0");
                case "s":
                  return String(u.$s);
                case "ss":
                  return S.s(u.$s, 2, "0");
                case "SSS":
                  return S.s(u.$ms, 3, "0");
                case "Z":
                  return c;
              }
              return null;
            }(Y) || c.replace(":", "");
          });
        }, o.utcOffset = function() {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, o.diff = function(r, u, a) {
          var d, c = this, V = S.p(u), M = b(r), T = (M.utcOffset() - this.utcOffset()) * i, O = this - M, H = function() {
            return S.m(c, M);
          };
          switch (V) {
            case q:
              d = H() / 12;
              break;
            case h:
              d = H();
              break;
            case C:
              d = H() / 3;
              break;
            case z:
              d = (O - T) / 6048e5;
              break;
            case v:
              d = (O - T) / 864e5;
              break;
            case y:
              d = O / l;
              break;
            case s:
              d = O / i;
              break;
            case $:
              d = O / n;
              break;
            default:
              d = O;
          }
          return a ? d : S.a(d);
        }, o.daysInMonth = function() {
          return this.endOf(h).$D;
        }, o.$locale = function() {
          return W[this.$L];
        }, o.locale = function(r, u) {
          if (!r)
            return this.$L;
          var a = this.clone(), d = ee(r, u, !0);
          return d && (a.$L = d), a;
        }, o.clone = function() {
          return S.w(this.$d, this);
        }, o.toDate = function() {
          return new Date(this.valueOf());
        }, o.toJSON = function() {
          return this.isValid() ? this.toISOString() : null;
        }, o.toISOString = function() {
          return this.$d.toISOString();
        }, o.toString = function() {
          return this.$d.toUTCString();
        }, p;
      }(), ye = te.prototype;
      return b.prototype = ye, [["$ms", g], ["$s", $], ["$m", s], ["$H", y], ["$W", v], ["$M", h], ["$y", q], ["$D", _]].forEach(function(p) {
        ye[p[1]] = function(o) {
          return this.$g(o, p[0], p[1]);
        };
      }), b.extend = function(p, o) {
        return p.$i || (p(o, te, b), p.$i = !0), b;
      }, b.locale = ee, b.isDayjs = he, b.unix = function(p) {
        return b(1e3 * p);
      }, b.en = W[P], b.Ls = W, b.p = {}, b;
    });
  }(de)), de.exports;
}
var ie = Me();
const f = /* @__PURE__ */ se(ie), A = (e, t, n) => {
  const i = `${e < 10 ? "0" : ""}${e}`, l = `${t < 10 ? "0" : ""}${t}`;
  return `${n}-${l}-${i}`;
}, re = (e, t) => {
  const n = `${e < 10 ? "0" : ""}${e}`, i = `${t < 10 ? "0" : ""}${t}`;
  return `${n}:${i}:00`;
}, me = (e) => e.sort(
  (n, i) => n.unix() - i.unix()
);
var we = { exports: {} };
(function(e, t) {
  (function(n, i) {
    e.exports = i(Me());
  })(ae, function(n) {
    function i($) {
      return $ && typeof $ == "object" && "default" in $ ? $ : { default: $ };
    }
    var l = i(n), g = { name: "id", weekdays: "Minggu_Senin_Selasa_Rabu_Kamis_Jumat_Sabtu".split("_"), months: "Januari_Februari_Maret_April_Mei_Juni_Juli_Agustus_September_Oktober_November_Desember".split("_"), weekdaysShort: "Min_Sen_Sel_Rab_Kam_Jum_Sab".split("_"), monthsShort: "Jan_Feb_Mar_Apr_Mei_Jun_Jul_Agt_Sep_Okt_Nov_Des".split("_"), weekdaysMin: "Mg_Sn_Sl_Rb_Km_Jm_Sb".split("_"), weekStart: 1, formats: { LT: "HH.mm", LTS: "HH.mm.ss", L: "DD/MM/YYYY", LL: "D MMMM YYYY", LLL: "D MMMM YYYY [pukul] HH.mm", LLLL: "dddd, D MMMM YYYY [pukul] HH.mm" }, relativeTime: { future: "dalam %s", past: "%s yang lalu", s: "beberapa detik", m: "semenit", mm: "%d menit", h: "sejam", hh: "%d jam", d: "sehari", dd: "%d hari", M: "sebulan", MM: "%d bulan", y: "setahun", yy: "%d tahun" }, ordinal: function($) {
      return $ + ".";
    } };
    return l.default.locale(g, null, !0), g;
  });
})(we);
var Re = we.exports;
const be = /* @__PURE__ */ se(Re);
var Te = { exports: {} };
(function(e, t) {
  (function(n, i) {
    e.exports = i();
  })(ae, function() {
    return function(n, i, l) {
      i.prototype.isToday = function() {
        var g = "YYYY-MM-DD", $ = l();
        return this.format(g) === $.format(g);
      };
    };
  });
})(Te);
var Be = Te.exports;
const Ee = /* @__PURE__ */ se(Be);
var Oe = { exports: {} };
(function(e, t) {
  (function(n, i) {
    e.exports = i();
  })(ae, function() {
    return function(n, i, l) {
      var g = i.prototype, $ = function(h) {
        return h && (h.indexOf ? h : h.s);
      }, s = function(h, C, q, _, Z) {
        var B = h.name ? h : h.$locale(), oe = $(B[C]), le = $(B[q]), E = oe || le.map(function(P) {
          return P.slice(0, _);
        });
        if (!Z)
          return E;
        var ue = B.weekStart;
        return E.map(function(P, W) {
          return E[(W + (ue || 0)) % 7];
        });
      }, y = function() {
        return l.Ls[l.locale()];
      }, v = function(h, C) {
        return h.formats[C] || function(q) {
          return q.replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g, function(_, Z, B) {
            return Z || B.slice(1);
          });
        }(h.formats[C.toUpperCase()]);
      }, z = function() {
        var h = this;
        return { months: function(C) {
          return C ? C.format("MMMM") : s(h, "months");
        }, monthsShort: function(C) {
          return C ? C.format("MMM") : s(h, "monthsShort", "months", 3);
        }, firstDayOfWeek: function() {
          return h.$locale().weekStart || 0;
        }, weekdays: function(C) {
          return C ? C.format("dddd") : s(h, "weekdays");
        }, weekdaysMin: function(C) {
          return C ? C.format("dd") : s(h, "weekdaysMin", "weekdays", 2);
        }, weekdaysShort: function(C) {
          return C ? C.format("ddd") : s(h, "weekdaysShort", "weekdays", 3);
        }, longDateFormat: function(C) {
          return v(h.$locale(), C);
        }, meridiem: this.$locale().meridiem, ordinal: this.$locale().ordinal };
      };
      g.localeData = function() {
        return z.bind(this)();
      }, l.localeData = function() {
        var h = y();
        return { firstDayOfWeek: function() {
          return h.weekStart || 0;
        }, weekdays: function() {
          return l.weekdays();
        }, weekdaysShort: function() {
          return l.weekdaysShort();
        }, weekdaysMin: function() {
          return l.weekdaysMin();
        }, months: function() {
          return l.months();
        }, monthsShort: function() {
          return l.monthsShort();
        }, longDateFormat: function(C) {
          return v(h, C);
        }, meridiem: h.meridiem, ordinal: h.ordinal };
      }, l.months = function() {
        return s(y(), "months");
      }, l.monthsShort = function() {
        return s(y(), "monthsShort", "months", 3);
      }, l.weekdays = function(h) {
        return s(y(), "weekdays", null, null, h);
      }, l.weekdaysShort = function(h) {
        return s(y(), "weekdaysShort", "weekdays", 3, h);
      }, l.weekdaysMin = function(h) {
        return s(y(), "weekdaysMin", "weekdays", 2, h);
      };
    };
  });
})(Oe);
var Ue = Oe.exports;
const Je = /* @__PURE__ */ se(Ue);
f.extend(Ee);
f.extend(Je);
const Ge = Ce({
  emits: {
    change: (e) => !0,
    changeTime: (e) => !0,
    save: () => !0
  },
  props: {
    closeOnSelect: {
      required: !1,
      type: Boolean
    },
    datepickerElem: {
      required: !1,
      type: Object
    },
    inputWrapper: {
      required: !1,
      type: Object
    },
    locale: {
      required: !1,
      type: String
    },
    max: {
      required: !1,
      type: String
    },
    min: {
      required: !1,
      type: String
    },
    overrideDateSelectable: {
      required: !1,
      type: Function
    },
    overrideDateStyle: {
      required: !1,
      type: Function
    },
    range: {
      required: !1,
      type: Boolean
    },
    saveText: {
      required: !1,
      type: String
    },
    show: {
      required: !0,
      type: Boolean
    },
    type: {
      default: "date",
      required: !0,
      type: String
    },
    value: {
      required: !1,
      type: Object
    }
  },
  name: "sb-form-date-picker-popup",
  components: {
    "sb-button": Fe
  },
  data() {
    return {
      lastHoverDate: null,
      localShowContainer: "calendar",
      parentWithScroll: null,
      popupCurrentValue: {
        date: 0,
        hour: 0,
        minute: 0,
        month: 0,
        year: 0
      },
      popupStyles: {
        left: "0",
        top: "0"
      },
      selectedHourIndex: 0,
      selectedMinuteIndex: 0
    };
  },
  computed: {
    getDates() {
      const e = A(
        1,
        this.popupCurrentValue.month + 1,
        this.popupCurrentValue.year
      ), t = f(e), n = t.daysInMonth(), i = t.startOf("month").day(), l = t.subtract(1, "month").daysInMonth(), g = [
        ...Array(n).keys()
      ].map((v) => ({
        value: v + 1
      })), $ = [
        ...Array(i).keys()
      ].map((v) => ({
        disabled: !0,
        value: v + 1 + l - i,
        viewOnly: !0
      })), s = [
        ...Array(42 - (i + n)).keys()
      ].map((v) => ({
        disabled: !0,
        value: v + 1,
        viewOnly: !0
      }));
      return [
        ...$,
        ...g,
        ...s
      ];
    },
    getDays() {
      return f.weekdaysShort();
    },
    getFooterIcon() {
      return this.localShowContainer !== "calendar" && this.localShowContainer !== "hour-list" && this.localShowContainer !== "minute-list" ? Ve() : ke();
    },
    getYears() {
      const e = f().year(), t = Math.floor(e / 100) * 100;
      return [...Array(200).keys()].map(
        (i) => t - 100 + i + 1
      );
    },
    iconAngleDoubleLeft() {
      return Ie();
    },
    iconAngleDoubleRight() {
      return Ae();
    },
    iconAngleDown() {
      return Ne();
    },
    iconAngleLeft() {
      return _e();
    },
    iconAngleRight() {
      return We();
    },
    iconAngleUp() {
      return je();
    },
    isSaveDisabled() {
      if (this.range) {
        const e = this.value;
        return !e || e && (e == null ? void 0 : e.length) < 2;
      }
      return !1;
    }
  },
  methods: {
    getDisplayTimeHour(e) {
      if (this.range) {
        const n = this.popupCurrentValue.hour[e];
        return `${n < 10 ? "0" : ""}${n}`;
      }
      const t = this.popupCurrentValue.hour;
      return `${t < 10 ? "0" : ""}${t}`;
    },
    getDisplayTimeMinute(e) {
      if (this.range) {
        const n = this.popupCurrentValue.minute[e];
        return `${n < 10 ? "0" : ""}${n}`;
      }
      const t = this.popupCurrentValue.minute;
      return `${t < 10 ? "0" : ""}${t}`;
    },
    getMonthText(e, t = !1) {
      return t ? f.monthsShort()[e] : f.months()[e];
    },
    handleClickHour(e) {
      this.range ? this.popupCurrentValue.hour[this.selectedHourIndex] = e : this.popupCurrentValue.hour = e, this.localShowContainer = "time", this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleClickMinute(e) {
      this.range ? this.popupCurrentValue.minute[this.selectedMinuteIndex] = e : this.popupCurrentValue.minute = e, this.localShowContainer = "time", this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleClickMonth(e) {
      this.popupCurrentValue.month = e, this.localShowContainer = "calendar", this.$nextTick(() => {
        if (this.type === "month") {
          const t = A(
            1,
            this.popupCurrentValue.month + 1,
            f().year()
          );
          this.$emit("change", f(t));
        }
      });
    },
    handleClickYear(e) {
      this.popupCurrentValue.year = e, this.localShowContainer = "calendar", this.$nextTick(() => {
        if (this.type === "year") {
          const t = A(
            1,
            1,
            this.popupCurrentValue.year
          );
          this.$emit("change", f(t));
        }
      });
    },
    handleDateMouseover({ disabled: e, value: t }) {
      if (!this.isDateDisabled(t) && !e && this.value && this.value.length < 2) {
        const n = A(
          t,
          this.popupCurrentValue.month + 1,
          this.popupCurrentValue.year
        );
        this.lastHoverDate = f(n);
      }
    },
    handleFooterClick() {
      this.localShowContainer !== "calendar" && this.localShowContainer !== "hour-list" && this.localShowContainer !== "minute-list" ? this.localShowContainer = "calendar" : this.localShowContainer = "time";
    },
    handleLocale() {
      this.locale && this.locale !== "en" && f.locale(be);
    },
    handleNavMonth(e) {
      e < 0 ? this.popupCurrentValue.month < 1 ? (this.popupCurrentValue.month = 11, this.popupCurrentValue.year -= 1) : this.popupCurrentValue.month -= 1 : this.popupCurrentValue.month > 10 ? (this.popupCurrentValue.month = 0, this.popupCurrentValue.year += 1) : this.popupCurrentValue.month += 1;
    },
    handleNavTime(e, t, n) {
      this.range ? this.handleNavTimeRange(e, t, n) : this.handleNavTimeNotRange(e, t);
    },
    handleNavTimeNotRange(e, t) {
      const n = this.popupCurrentValue.hour, i = this.popupCurrentValue.minute;
      t === "hour" ? e < 0 ? n < 1 ? this.popupCurrentValue.hour = 23 : this.popupCurrentValue.hour += e : n > 22 ? this.popupCurrentValue.hour = 0 : this.popupCurrentValue.hour += e : e < 0 ? i < 1 ? this.popupCurrentValue.minute = 59 : this.popupCurrentValue.minute += e : i > 58 ? this.popupCurrentValue.minute = 0 : this.popupCurrentValue.minute += e, this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleNavTimeRange(e, t, n) {
      const i = this.popupCurrentValue.hour[n], l = this.popupCurrentValue.minute[0];
      t === "hour" ? e < 0 ? i < 1 ? this.popupCurrentValue.hour[n] = 23 : this.popupCurrentValue.hour[n] += e : i > 22 ? this.popupCurrentValue.hour[n] = 0 : this.popupCurrentValue.hour[n] += e : e < 0 ? l < 1 ? this.popupCurrentValue.minute[n] = 59 : this.popupCurrentValue.minute[n] += e : l > 58 ? this.popupCurrentValue.minute[n] = 0 : this.popupCurrentValue.minute[n] += e, this.$nextTick(() => {
        this.setModelValueTime();
      });
    },
    handleNavYear(e) {
      this.popupCurrentValue.year += e;
    },
    handleOverrideDateStyle(e) {
      return this.overrideDateStyle ? this.overrideDateStyle(e) : {};
    },
    handleParentScroll(e) {
      const t = $e(this.$el);
      this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
        this.setPopupPosition();
      }), t && (e ? t.addEventListener("scroll", () => {
        this.setPopupPosition();
      }) : t.removeEventListener("scroll", () => {
        this.setPopupPosition();
      })), this.$nextTick(() => {
        this.parentWithScroll = t;
      });
    },
    handleSave() {
      if (this.type === "time")
        this.setModelValueTime();
      else if (this.type === "month") {
        const e = A(
          1,
          this.popupCurrentValue.month + 1,
          f().year()
        );
        this.$emit("change", f(e));
      } else if (this.type === "year") {
        const e = A(
          1,
          1,
          this.popupCurrentValue.year
        );
        this.$emit("change", f(e));
      } else
        (!this.range || this.range && (!this.value || this.value.length < 2)) && this.setModelValueDate(this.popupCurrentValue.date);
      this.$emit("save");
    },
    handleSelectDate({ disabled: e, value: t }) {
      !e && !this.isDateDisabled(t) && (this.popupCurrentValue.date = t, this.setModelValueDate(t));
    },
    handleShowHourList(e) {
      const t = this.$refs[`hour-${this.popupCurrentValue.hour}`];
      (t == null ? void 0 : t.length) > 0 && t[0].scrollIntoView({
        block: "center"
      }), this.selectedHourIndex = e, this.localShowContainer = "hour-list";
    },
    handleShowMinuteList(e) {
      const t = this.$refs[`minute-${this.popupCurrentValue.minute}`];
      (t == null ? void 0 : t.length) > 0 && t[0].scrollIntoView({
        block: "center"
      }), this.selectedMinuteIndex = e, this.localShowContainer = "minute-list";
    },
    handleShowMonthList() {
      this.localShowContainer = "month-list";
    },
    handleShowYearList() {
      const e = this.$refs[`year-${this.popupCurrentValue.year}`];
      (e == null ? void 0 : e.length) > 0 && e[0].scrollIntoView({
        block: "center"
      }), this.localShowContainer = "year-list";
    },
    isCurrentDate({ value: e, viewOnly: t }) {
      if (this.popupCurrentValue.year !== null && this.popupCurrentValue.month !== null && !t) {
        const n = A(
          e,
          this.popupCurrentValue.month + 1,
          this.popupCurrentValue.year
        );
        return f(n).isToday();
      }
      return !1;
    },
    isDateDisabled(e) {
      const t = A(
        e,
        this.popupCurrentValue.month + 1,
        this.popupCurrentValue.year
      );
      if (this.overrideDateSelectable)
        return !this.overrideDateSelectable(
          f(t).toISOString()
        );
      if (this.max || this.min) {
        const n = () => this.max ? f(this.max).endOf("day").diff(f(t)) <= 0 : !1, i = () => {
          if (this.min) {
            const l = f(this.min).subtract(1, "day").startOf("day");
            return f(t).diff(l) <= 0;
          }
          return !1;
        };
        return n() || i();
      }
      return !1;
    },
    isDateInRange({ value: e }) {
      if (this.value && this.range) {
        const t = [...this.value], n = () => t.length > 1 ? t : this.lastHoverDate ? [...t, this.lastHoverDate] : [];
        if (this.lastHoverDate || t.length > 1) {
          const i = A(
            e,
            this.popupCurrentValue.month + 1,
            this.popupCurrentValue.year
          ), l = me(
            n()
          ), g = f(i);
          return g.unix() >= l[0].unix() && g.unix() <= l[1].unix();
        }
      }
      return !1;
    },
    isDateSelected({ value: e, viewOnly: t }) {
      if (this.popupCurrentValue.year !== null && this.popupCurrentValue.month !== null && !t && this.value) {
        const n = A(
          e,
          this.popupCurrentValue.month + 1,
          this.popupCurrentValue.year
        );
        return this.range ? [
          ...this.value || []
        ].some((l) => f(n).startOf("day").diff(l.startOf("day")) === 0) : f(n).startOf("day").diff(this.value.startOf("day")) === 0;
      }
      return !1;
    },
    isHourSelected(e) {
      return this.popupCurrentValue.hour === e;
    },
    isMinuteSelected(e) {
      return this.popupCurrentValue.minute === e;
    },
    isMonthSelected(e) {
      return this.popupCurrentValue.month === e;
    },
    isYearSelected(e) {
      return this.popupCurrentValue.year === e;
    },
    setModelValueDate(e) {
      const t = A(
        e,
        this.popupCurrentValue.month + 1,
        this.popupCurrentValue.year
      );
      if (this.type === "datetime")
        if (this.range) {
          const n = !this.value || this.value && this.value.length > 1 ? 0 : 1, i = this.popupCurrentValue.hour[n], l = this.popupCurrentValue.minute[n], g = re(
            i,
            l
          );
          this.$emit(
            "change",
            f(`${t} ${g}`)
          );
        } else {
          const n = this.popupCurrentValue.hour, i = this.popupCurrentValue.minute, l = re(
            n,
            i
          );
          this.$emit(
            "change",
            f(`${t} ${l}`)
          );
        }
      else
        this.$emit("change", f(t));
    },
    setModelValueTime() {
      if (this.range) {
        const t = [...this.value || [
          f(),
          f()
        ]].map(
          (n, i) => {
            const l = this.popupCurrentValue.hour[i], g = this.popupCurrentValue.minute[i], $ = re(
              l,
              g
            ), s = `${n.format(
              "YYYY-MM-DD"
            )} ${$}`;
            return f(s);
          }
        );
        this.$emit("changeTime", t);
      } else {
        const e = this.value || f(), t = this.popupCurrentValue.hour, n = this.popupCurrentValue.minute, i = re(t, n), l = `${e.format(
          "YYYY-MM-DD"
        )} ${i}`;
        this.$emit("change", f(l));
      }
    },
    setPopupPosition() {
      if (this.inputWrapper && this.$refs["popup-wrapper"]) {
        const t = this.inputWrapper.getBoundingClientRect(), n = this.$refs["popup-wrapper"].getBoundingClientRect(), i = document.body.getBoundingClientRect().height - (t.height + t.y) <= n.height, l = () => t.width > n.width || t.width < n.width ? t.x + (t.width - n.width) / 2 : t.x;
        i ? this.popupStyles = {
          left: `${l() + 2}px`,
          top: `${t.y - 6 - n.height}px`
        } : this.popupStyles = {
          left: `${l() + 2}px`,
          top: `${t.y + t.height}px`
        }, this.$nextTick(() => {
          const g = this.$refs[`year-${this.popupCurrentValue.year}`];
          (g == null ? void 0 : g.length) > 0 && g[0].scrollIntoView({
            block: "center"
          });
        });
      }
    },
    setPopupValue() {
      if (this.value)
        if (this.range) {
          const e = this.value, t = [...e].map(
            (g) => g.minute()
          ), n = [...e].map(
            (g) => g.hour()
          ), i = this.popupCurrentValue.hour[this.popupCurrentValue.hour.length - 1], l = this.popupCurrentValue.minute[this.popupCurrentValue.minute.length - 1];
          this.popupCurrentValue = {
            date: e[e.length - 1].date(),
            hour: [
              ...n,
              ...e.length < 2 ? [i] : []
            ],
            minute: [
              ...t,
              ...e.length < 2 ? [l] : []
            ],
            month: e[e.length - 1].month(),
            year: e[e.length - 1].year()
          };
        } else {
          const e = this.value;
          this.popupCurrentValue = {
            date: e.date(),
            hour: e.hour(),
            minute: e.minute(),
            month: e.month(),
            year: e.year()
          };
        }
      else if (this.min) {
        const e = f(this.min).startOf("month");
        this.popupCurrentValue = {
          date: e.date(),
          hour: this.range ? [e.hour(), e.hour()] : e.hour(),
          minute: this.range ? [e.minute(), e.minute()] : e.minute(),
          month: e.month(),
          year: e.year()
        };
      } else {
        const e = f();
        this.popupCurrentValue = {
          date: e.date(),
          hour: this.range ? [e.hour(), e.hour()] : e.hour(),
          minute: this.range ? [e.minute(), e.minute()] : e.minute(),
          month: e.month(),
          year: e.year()
        };
      }
    }
  },
  watch: {
    show(e, t) {
      this.handleParentScroll(e), t && !e ? (this.setPopupValue(), this.type === "time" ? this.localShowContainer = "time" : this.localShowContainer = "calendar") : !t && e && this.$nextTick(() => this.setPopupPosition());
    },
    type: {
      handler(e) {
        e === "time" ? this.localShowContainer = "time" : this.localShowContainer = "calendar";
      },
      immediate: !0
    },
    value: {
      deep: !0,
      handler() {
        this.setPopupValue();
      },
      immediate: !0
    }
  },
  mounted() {
    this.handleLocale(), this.setPopupPosition(), this.parentWithScroll = $e(
      this.datepickerElem
    );
  },
  unmounted() {
    this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
      this.setPopupPosition();
    });
  }
}), Ke = {
  key: 0,
  class: "month-list-wrapper"
}, ze = ["onClick"], Ze = {
  key: 1,
  class: "year-list-wrapper"
}, Qe = ["onClick"], Xe = { class: "hour-list-wrapper" }, xe = ["onClick"], et = { class: "minute-list-wrapper" }, tt = ["onClick"], nt = {
  key: 3,
  class: "header"
}, rt = { class: "nav-wrapper" }, it = { class: "current" }, at = { class: "nav-wrapper" }, st = {
  key: 4,
  class: "body"
}, ot = { class: "days-wrapper" }, lt = { class: "dates-wrapper" }, ut = ["onClick", "onMouseover"], ht = {
  key: 1,
  class: "time-wrapper"
}, pt = { class: "value-wrapper" }, dt = { class: "time-nav" }, ct = ["onClick"], ft = { class: "time-nav down" }, mt = /* @__PURE__ */ D("div", { class: "separator" }, ":", -1), yt = { class: "value-wrapper" }, gt = { class: "time-nav" }, vt = ["onClick"], $t = { class: "time-nav down" };
function St(e, t, n, i, l, g) {
  const $ = ce("sb-button");
  return m(), L(Ye, { to: "body" }, [
    e.show ? (m(), k("div", {
      key: 0,
      class: G(["sb-datepicker-popup-wrapper", [
        `container-${e.localShowContainer}`,
        e.type,
        e.range ? "range" : "",
        e.show ? "show" : "",
        e.type === "time" ? "time-only" : "",
        e.closeOnSelect ? "" : "with-save"
      ]]),
      ref: "popup-wrapper",
      style: ge(e.popupStyles)
    }, [
      e.type !== "time" && e.type !== "year" ? (m(), k("div", Ke, [
        (m(!0), k(j, null, K([...Array(12).keys()], (s, y) => (m(), k("div", {
          class: G(["month", {
            selected: e.isMonthSelected(s)
          }]),
          key: `month-${y}`,
          onClick: w((v) => e.handleClickMonth(s), ["stop"])
        }, F(e.getMonthText(s, !0)), 11, ze))), 128))
      ])) : I("", !0),
      e.type !== "time" && e.type !== "month" ? (m(), k("div", Ze, [
        (m(!0), k(j, null, K(e.getYears, (s, y) => (m(), k("div", {
          class: G(["year", {
            selected: e.isYearSelected(s)
          }]),
          key: `year-${y}`,
          ref_for: !0,
          ref: `year-${s}`,
          onClick: w((v) => e.handleClickYear(s), ["stop"])
        }, F(s), 11, Qe))), 128))
      ])) : I("", !0),
      e.type === "time" || e.type === "datetime" ? (m(), k(j, { key: 2 }, [
        D("div", Xe, [
          (m(!0), k(j, null, K([...Array(24).keys()], (s, y) => (m(), k("div", {
            class: G(["hour", {
              selected: e.isHourSelected(s)
            }]),
            key: `hour-${y}`,
            ref_for: !0,
            ref: `hour-${s}`,
            onClick: w((v) => e.handleClickHour(s), ["stop"])
          }, F(`${s < 10 ? "0" : ""}${s}`), 11, xe))), 128))
        ]),
        D("div", et, [
          (m(!0), k(j, null, K([...Array(60).keys()], (s, y) => (m(), k("div", {
            class: G(["minute", {
              selected: e.isMinuteSelected(s)
            }]),
            key: `minute-${y}`,
            ref_for: !0,
            ref: `minute-${s}`,
            onClick: w((v) => e.handleClickMinute(s), ["stop"])
          }, F(`${s < 10 ? "0" : ""}${s}`), 11, tt))), 128))
        ])
      ], 64)) : I("", !0),
      e.type !== "time" && e.type !== "month" && e.type !== "year" ? (m(), k("div", nt, [
        D("div", rt, [
          D("div", {
            class: "nav",
            onClick: t[0] || (t[0] = w((s) => e.handleNavYear(-1), ["stop"]))
          }, [
            (m(), L(N(e.iconAngleDoubleLeft)))
          ]),
          D("div", {
            class: "nav",
            onClick: t[1] || (t[1] = w((s) => e.handleNavMonth(-1), ["stop"]))
          }, [
            (m(), L(N(e.iconAngleLeft)))
          ])
        ]),
        D("div", it, [
          D("div", {
            class: "year",
            onClick: t[2] || (t[2] = w((...s) => e.handleShowYearList && e.handleShowYearList(...s), ["stop"]))
          }, F(e.popupCurrentValue.year), 1),
          D("div", {
            class: "month",
            onClick: t[3] || (t[3] = w((...s) => e.handleShowMonthList && e.handleShowMonthList(...s), ["stop"]))
          }, F(e.getMonthText(e.popupCurrentValue.month)), 1)
        ]),
        D("div", at, [
          D("div", {
            class: "nav",
            onClick: t[4] || (t[4] = w((s) => e.handleNavMonth(1), ["stop"]))
          }, [
            (m(), L(N(e.iconAngleRight)))
          ]),
          D("div", {
            class: "nav",
            onClick: t[5] || (t[5] = w((s) => e.handleNavYear(1), ["stop"]))
          }, [
            (m(), L(N(e.iconAngleDoubleRight)))
          ])
        ])
      ])) : I("", !0),
      e.type !== "month" && e.type !== "year" ? (m(), k("div", st, [
        e.type !== "time" ? (m(), k(j, { key: 0 }, [
          D("div", ot, [
            (m(!0), k(j, null, K(e.getDays, (s, y) => (m(), k("div", {
              class: "day",
              key: `day-${y}`
            }, F(s), 1))), 128))
          ]),
          D("div", lt, [
            (m(!0), k(j, null, K(e.getDates, (s, y) => (m(), k("div", {
              class: G(["date", {
                "in-range": e.isDateInRange(s),
                current: e.isCurrentDate(s),
                disabled: s.disabled || e.isDateDisabled(s.value),
                selected: e.isDateSelected(s)
              }]),
              key: `date-${y}`,
              style: ge(e.handleOverrideDateStyle(s)),
              onClick: w((v) => e.handleSelectDate(s), ["stop"]),
              onMouseover: (v) => e.handleDateMouseover(s)
            }, F(s.value), 47, ut))), 128))
          ])
        ], 64)) : I("", !0),
        e.type !== "date" ? (m(), k("div", ht, [
          (m(!0), k(j, null, K(e.range ? [0, 1] : [0], (s, y) => (m(), k("div", {
            class: "time",
            key: `time-picker-${y}`
          }, [
            D("div", pt, [
              D("div", dt, [
                (m(), L(N(e.iconAngleUp), {
                  onClick: w((v) => e.handleNavTime(1, "hour", y), ["stop"])
                }, null, 8, ["onClick"]))
              ]),
              D("div", {
                class: "value",
                onClick: w((v) => e.handleShowHourList(y), ["stop"])
              }, F(e.getDisplayTimeHour(y)), 9, ct),
              D("div", ft, [
                (m(), L(N(e.iconAngleDown), {
                  onClick: w((v) => e.handleNavTime(-1, "hour", y), ["stop"])
                }, null, 8, ["onClick"]))
              ])
            ]),
            mt,
            D("div", yt, [
              D("div", gt, [
                (m(), L(N(e.iconAngleUp), {
                  onClick: w((v) => e.handleNavTime(1, "minute", y), ["stop"])
                }, null, 8, ["onClick"]))
              ]),
              D("div", {
                class: "value",
                onClick: w((v) => e.handleShowMinuteList(y), ["stop"])
              }, F(e.getDisplayTimeMinute(y)), 9, vt),
              D("div", $t, [
                (m(), L(N(e.iconAngleDown), {
                  onClick: w((v) => e.handleNavTime(-1, "minute", y), ["stop"])
                }, null, 8, ["onClick"]))
              ])
            ])
          ]))), 128))
        ])) : I("", !0)
      ])) : I("", !0),
      !e.closeOnSelect || e.type === "datetime" ? (m(), k("div", {
        key: 5,
        class: G(["footer", {
          "two-button": !e.closeOnSelect && e.type === "datetime"
        }])
      }, [
        e.type === "datetime" ? (m(), L($, {
          key: 0,
          "no-elevation": "",
          class: "button-time",
          color: "secondary",
          tabindex: "-1",
          type: "button",
          variant: "text",
          onClick: w(e.handleFooterClick, ["stop"])
        }, {
          default: fe(() => [
            (m(), L(N(e.getFooterIcon)))
          ]),
          _: 1
        }, 8, ["onClick"])) : I("", !0),
        e.closeOnSelect ? I("", !0) : (m(), L($, {
          key: 1,
          disabled: e.isSaveDisabled,
          "no-elevation": "",
          color: "accent",
          tabindex: "-1",
          type: "button",
          variant: "text",
          onClick: w(e.handleSave, ["stop"])
        }, {
          default: fe(() => [
            Le(F(e.saveText || "Save"), 1)
          ]),
          _: 1
        }, 8, ["disabled", "onClick"]))
      ], 2)) : I("", !0)
    ], 6)) : I("", !0)
  ]);
}
const Ct = /* @__PURE__ */ De(Ge, [["render", St]]), Vt = Ce({
  emits: {
    "update:modelValue": (e) => !0,
    change: (e) => !0,
    input: (e) => !0
  },
  props: {
    allowClear: {
      required: !1,
      type: Boolean
    },
    closeOnSelect: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    format: {
      required: !1,
      type: String
    },
    isError: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    locale: {
      required: !1,
      type: String
    },
    max: {
      required: !1,
      type: String
    },
    min: {
      required: !1,
      type: String
    },
    modelValue: {
      required: !1,
      type: [String, Object]
    },
    noIcon: {
      required: !1,
      type: Boolean
    },
    overrideDateSelectable: {
      required: !1,
      type: Function
    },
    overrideDateStyle: {
      required: !1,
      type: Function
    },
    placeholder: {
      required: !1,
      type: String
    },
    range: {
      required: !1,
      type: Boolean
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    saveText: {
      required: !1,
      type: String
    },
    type: {
      default: "date",
      required: !1,
      type: String
    },
    value: {
      required: !1,
      type: [String, Object]
    },
    variant: {
      default: "default",
      required: !1,
      type: String
    }
  },
  name: "sb-form-date-picker",
  components: {
    "sb-input": He,
    "sb-datepicker-popup": Ct
  },
  data() {
    return {
      datepickerWrapper: null,
      icon: {
        onClick: null,
        placement: "append"
      },
      inputWrapper: null,
      localValue: null,
      localShow: !1,
      valueString: null
    };
  },
  computed: {
    getIcon() {
      return this.allowClear && this.localValue && this.localValue !== "" ? Pe() : this.type === "time" ? ke() : Ve();
    }
  },
  methods: {
    emitFinalValue() {
      if (this.localValue)
        if (typeof this.localValue == "object" && this.localValue.length) {
          const e = [
            ...this.localValue
          ].map((t) => t.toISOString());
          this.$emit("update:modelValue", e), this.$emit("input", e), this.$emit("change", e);
        } else {
          const e = this.localValue.toISOString();
          this.$emit("update:modelValue", e), this.$emit("input", e), this.$emit("change", e);
        }
      else
        this.$emit("update:modelValue", null), this.$emit("input", null), this.$emit("change", null);
    },
    getDefaultFormat() {
      switch (this.type) {
        case "datetime":
          return "YYYY-MM-DD HH:mm:ss";
        case "time":
          return "HH:mm:ss";
        case "month":
          return "YYYY-MM";
        case "year":
          return "YYYY";
        default:
          return "YYYY-MM-DD";
      }
    },
    handleClickIcon() {
      return this.allowClear && this.localValue && this.localValue !== "" ? this.handleUpdateModelValue(null) : !this.disabled && !this.readOnly ? this.handleOpenCalendar() : null;
    },
    handleClickOutsideDatepicker(e) {
      const t = e.target, n = this.$refs["datepicker-wrapper"];
      t && n && !n.contains(t) && !t.isSameNode(n) && (this.localShow = !1);
    },
    handleGenerateString() {
      var e;
      if ((e = this.localValue) != null && e.length && this.range) {
        const t = [...this.localValue];
        this.format ? this.valueString = t.map((n) => n.format(this.format)).join(" - ") : this.valueString = t.map(
          (n) => n.format(this.getDefaultFormat())
        ).join(" - ");
      } else
        !this.range && typeof this.localValue == "object" ? this.format ? this.valueString = this.localValue.format(this.format) : this.valueString = this.localValue.format(
          this.getDefaultFormat()
        ) : this.valueString = null;
    },
    handleKeyDown(e) {
      const t = e;
      t.key === "Backspace" ? (this.localValue = null, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      })) : t.key === "Tab" ? (this.localShow = !1, this.$el.blur()) : e.preventDefault();
    },
    handleLocale() {
      this.locale && this.locale !== "en" && f.locale(be);
    },
    handleOnChange(e) {
      if (!this.range)
        this.handleUpdateModelValue(e);
      else {
        const n = me((() => this.localValue && this.localValue.length === 1 ? [...this.localValue, e] : [e])());
        this.localValue = [...n], this.$nextTick(() => {
          this.localValue.length > 1 && this.handleRangeUpdateModelValue();
        });
      }
    },
    handleOnChangeTime(e) {
      const t = me(e);
      this.localValue = [...t], this.$nextTick(() => this.handleRangeUpdateModelValue());
    },
    handleOnSave() {
      this.localShow = !1, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      });
    },
    handleOpenCalendar() {
      if (!this.disabled && !this.readOnly) {
        const t = this.$el.getElementsByTagName("input");
        if ((t == null ? void 0 : t.length) > 0) {
          const n = t.item(0);
          n == null || n.focus();
        }
        this.localShow = !0;
      }
    },
    handleUpdateModelValue(e) {
      this.localValue = e, this.closeOnSelect && (this.localShow = !1, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      }));
    },
    handleRangeUpdateModelValue() {
      this.closeOnSelect && (this.localShow = !1, this.$nextTick(() => {
        this.handleGenerateString(), this.emitFinalValue();
      }));
    },
    setLocalValue(e) {
      if (!e || (e == null ? void 0 : e.length) < 1)
        this.valueString = null, this.localValue = null;
      else if (this.range) {
        const t = [
          ie.isDayjs(e[0]) ? e[0] : f(e[0]),
          ie.isDayjs(e[1]) ? e[1] : f(e[1])
        ];
        if ([...t].some(
          (i) => !i.isValid()
        ))
          this.valueString = null, this.localValue = null;
        else {
          if (this.format) {
            const i = t[1].format(
              this.format
            ), l = t[0].format(
              this.format
            );
            this.valueString = `${l} - ${i}`;
          } else {
            const i = t[1].format(
              this.getDefaultFormat()
            ), l = t[0].format(
              this.getDefaultFormat()
            );
            this.valueString = `${l} - ${i}`;
          }
          this.localValue = t;
        }
      } else {
        const t = ie.isDayjs(e) ? e : f(e);
        t.isValid() ? (this.format ? this.valueString = t.format(
          this.format
        ) : this.valueString = t.format(
          this.getDefaultFormat()
        ), this.localValue = t) : (this.valueString = null, this.localValue = null);
      }
    }
  },
  watch: {
    localShow(e, t) {
      if (!e && t && this.range && (!this.localValue || this.localValue && this.localValue.length < 2))
        this.localValue = null;
      else if (!e) {
        const i = this.$el.getElementsByTagName("input");
        if ((i == null ? void 0 : i.length) > 0) {
          const l = i.item(0);
          l == null || l.blur();
        }
      }
    },
    modelValue: {
      deep: !0,
      handler(e) {
        this.setLocalValue(e);
      }
    },
    value: {
      deep: !0,
      handler(e) {
        this.setLocalValue(e);
      }
    }
  },
  mounted() {
    this.handleLocale(), this.setLocalValue(this.modelValue || this.value), this.icon.onClick = this.handleClickIcon;
    const e = this.$refs["input-wrapper"].$el.children, t = Array.from(e).find(
      (n) => n.classList.contains("input-group")
    );
    this.inputWrapper = t, document.addEventListener(
      "click",
      (n) => this.handleClickOutsideDatepicker(n)
    ), this.setLocalValue(this.localValue), this.datepickerWrapper = this.$el;
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideDatepicker(e)
    );
  }
});
const kt = ["tabindex"];
function Dt(e, t, n, i, l, g) {
  const $ = ce("sb-input"), s = ce("sb-datepicker-popup");
  return m(), k("div", pe({
    class: [{ error: e.isError, range: e.range }, "datepicker-wrapper"],
    tabindex: !e.disabled && !e.readOnly ? 0 : -1,
    ref: "datepicker-wrapper"
  }, { ...e.$attrs }, {
    onBlur: t[1] || (t[1] = () => e.localShow = !1),
    onFocus: t[2] || (t[2] = () => e.handleOpenCalendar())
  }), [
    ve($, pe({
      "error-message": e.errorMessage,
      "is-error": e.isError,
      "is-focus": e.localShow,
      label: e.label,
      placeholder: e.placeholder,
      tabindex: -1,
      value: e.valueString,
      variant: e.variant,
      ref: "input-wrapper",
      type: "text"
    }, {
      disabled: e.disabled,
      required: e.required,
      readOnly: e.readOnly,
      ...!e.noIcon && {
        icon: e.icon
      }
    }, {
      onFocus: t[0] || (t[0] = () => e.handleOpenCalendar()),
      onKeydown: e.handleKeyDown
    }), qe({ _: 2 }, [
      e.noIcon ? void 0 : {
        name: "icon-slot",
        fn: fe(() => [
          (m(), L(N(e.getIcon)))
        ]),
        key: "0"
      }
    ]), 1040, ["error-message", "is-error", "is-focus", "label", "placeholder", "value", "variant", "onKeydown"]),
    ve(s, pe({
      "datepicker-elem": e.datepickerWrapper,
      "close-on-select": e.closeOnSelect,
      "input-wrapper": e.inputWrapper,
      "override-date-selectable": e.overrideDateSelectable,
      "override-date-style": e.overrideDateStyle,
      show: e.localShow,
      value: e.localValue
    }, {
      max: e.max,
      min: e.min,
      range: e.range,
      saveText: e.saveText,
      type: e.type
    }, {
      onChange: e.handleOnChange,
      onChangeTime: e.handleOnChangeTime,
      onSave: e.handleOnSave
    }), null, 16, ["datepicker-elem", "close-on-select", "input-wrapper", "override-date-selectable", "override-date-style", "show", "value", "onChange", "onChangeTime", "onSave"])
  ], 16, kt);
}
const Ht = /* @__PURE__ */ De(Vt, [["render", Dt]]);
export {
  Ht as default
};
