import { IIcon, IMaskaOptions } from '../../interface';
import { PropType } from 'vue';
declare const _default: import("vue").DefineComponent<{
    autocomplete: {
        default: string;
        type: PropType<"on" | "off">;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    icon: {
        required: false;
        type: PropType<IIcon>;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isFocus: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    maskaOptions: {
        required: false;
        type: PropType<IMaskaOptions>;
    };
    modelValue: {
        required: false;
        type: PropType<string | null>;
    };
    pattern: {
        required: false;
        type: StringConstructor;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    textAlign: {
        default: string;
        type: PropType<"left" | "right">;
    };
    value: {
        required: false;
        type: PropType<string | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
}, unknown, {
    localIsFocus: boolean;
    localValue: any;
}, {
    getMaskaOptions(): {
        eager?: boolean | undefined;
        mask?: string | Function | string[] | undefined;
        tokens?: any;
        tokensReplace?: any;
        postProcess?: Function | undefined;
        preProcess?: Function | undefined;
        reversed?: boolean | undefined;
    };
    isFilled(): any;
}, {
    handleBlur(ev: Event): void;
    handleChange(ev: Event): void;
    handleClickIcon(ev: Event): void | undefined;
    handleClickOutsideInput(event: MouseEvent): void;
    handleErrorMessage(): any;
    handleInputFocus(ev: Event): void;
    handleMouseLeaveIcon(ev: Event): void | undefined;
    handleMouseOverIcon(ev: Event): void | undefined;
    toggleFocus(focus: boolean, event?: Event): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_value: string | null) => true;
    blur: (_event: Event) => true;
    focus: (_event: Event) => true;
    input: (_event: Event) => true;
    keydown: (_event: Event) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    autocomplete: {
        default: string;
        type: PropType<"on" | "off">;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    icon: {
        required: false;
        type: PropType<IIcon>;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isFocus: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    maskaOptions: {
        required: false;
        type: PropType<IMaskaOptions>;
    };
    modelValue: {
        required: false;
        type: PropType<string | null>;
    };
    pattern: {
        required: false;
        type: StringConstructor;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    textAlign: {
        default: string;
        type: PropType<"left" | "right">;
    };
    value: {
        required: false;
        type: PropType<string | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
}>> & {
    onFocus?: ((_event: Event) => any) | undefined;
    onBlur?: ((_event: Event) => any) | undefined;
    onInput?: ((_event: Event) => any) | undefined;
    onKeydown?: ((_event: Event) => any) | undefined;
    "onUpdate:modelValue"?: ((_value: string | null) => any) | undefined;
}, {
    required: boolean;
    disabled: boolean;
    variant: "default" | "flat";
    isError: boolean;
    isFocus: boolean;
    autocomplete: "on" | "off";
    readOnly: boolean;
    textAlign: "left" | "right";
}, {}>;
export default _default;
