/*! maska v2.1.10 | (c) Alexander Shabunevich | Released under the MIT license */
var W = Object.defineProperty, L = (a, t, e) => t in a ? W(a, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : a[t] = e, g = (a, t, e) => (L(a, typeof t != "symbol" ? t + "" : t, e), e);
const b = {
  "#": { pattern: /[0-9]/ },
  "@": { pattern: /[a-zA-Z]/ },
  "*": { pattern: /[a-zA-Z0-9]/ }
};
class w {
  constructor(t = {}) {
    g(this, "opts", {}), g(this, "memo", /* @__PURE__ */ new Map());
    const e = { ...t };
    if (e.tokens != null) {
      e.tokens = e.tokensReplace ? { ...e.tokens } : { ...b, ...e.tokens };
      for (const s of Object.values(e.tokens))
        typeof s.pattern == "string" && (s.pattern = new RegExp(s.pattern));
    } else
      e.tokens = b;
    Array.isArray(e.mask) && (e.mask.length > 1 ? e.mask = [...e.mask].sort((s, n) => s.length - n.length) : e.mask = e.mask[0] ?? ""), e.mask === "" && (e.mask = null), this.opts = e;
  }
  masked(t) {
    return this.process(t, this.findMask(t));
  }
  unmasked(t) {
    return this.process(t, this.findMask(t), !1);
  }
  isEager() {
    return this.opts.eager === !0;
  }
  isReversed() {
    return this.opts.reversed === !0;
  }
  completed(t) {
    const e = this.findMask(t);
    if (this.opts.mask == null || e == null)
      return !1;
    const s = this.process(t, e).length;
    return typeof this.opts.mask == "string" ? s >= this.opts.mask.length : typeof this.opts.mask == "function" ? s >= e.length : this.opts.mask.filter((n) => s >= n.length).length === this.opts.mask.length;
  }
  findMask(t) {
    const e = this.opts.mask;
    if (e == null)
      return null;
    if (typeof e == "string")
      return e;
    if (typeof e == "function")
      return e(t);
    const s = this.process(t, e.slice(-1).pop() ?? "", !1);
    return e.find((n) => this.process(t, n, !1).length >= s.length) ?? "";
  }
  escapeMask(t) {
    const e = [], s = [];
    return t.split("").forEach((n, i) => {
      n === "!" && t[i - 1] !== "!" ? s.push(i - s.length) : e.push(n);
    }), { mask: e.join(""), escaped: s };
  }
  process(t, e, s = !0) {
    var n;
    if (e == null)
      return t;
    const i = `value=${t},mask=${e},masked=${s ? 1 : 0}`;
    if (this.memo.has(i))
      return this.memo.get(i);
    const { mask: o, escaped: p } = this.escapeMask(e), h = [], m = this.opts.tokens != null ? this.opts.tokens : {}, l = this.isReversed() ? -1 : 1, c = this.isReversed() ? "unshift" : "push", v = this.isReversed() ? 0 : o.length - 1, S = this.isReversed() ? () => r > -1 && u > -1 : () => r < o.length && u < t.length, V = (k) => !this.isReversed() && k <= v || this.isReversed() && k >= v;
    let y, f = -1, r = this.isReversed() ? o.length - 1 : 0, u = this.isReversed() ? t.length - 1 : 0;
    for (; S(); ) {
      const k = o.charAt(r), d = m[k], E = (d == null ? void 0 : d.transform) != null ? d.transform(t.charAt(u)) : t.charAt(u);
      if (!p.includes(r) && d != null) {
        if (E.match(d.pattern) != null)
          h[c](E), d.repeated ? (f === -1 ? f = r : r === v && r !== f && (r = f - l), v === f && (r -= l)) : d.multiple && (r -= l), r += l;
        else if (d.multiple) {
          const P = ((n = h[u - l]) == null ? void 0 : n.match(d.pattern)) != null, R = o.charAt(r + l);
          P && R !== "" && m[R] == null ? (r += l, u -= l) : h[c]("");
        } else
          E === y ? y = void 0 : d.optional && (r += l, u -= l);
        u += l;
      } else
        s && !this.isEager() && h[c](k), E === k && !this.isEager() ? u += l : y = k, this.isEager() || (r += l);
      if (this.isEager())
        for (; V(r) && (m[o.charAt(r)] == null || p.includes(r)); )
          s ? h[c](o.charAt(r)) : o.charAt(r) === t.charAt(u) && (u += l), r += l;
    }
    return this.memo.set(i, h.join("")), this.memo.get(i);
  }
}
const T = (a) => JSON.parse(a.replaceAll("'", '"')), O = (a, t = {}) => {
  const e = { ...t };
  return a.dataset.maska != null && a.dataset.maska !== "" && (e.mask = j(a.dataset.maska)), a.dataset.maskaEager != null && (e.eager = M(a.dataset.maskaEager)), a.dataset.maskaReversed != null && (e.reversed = M(a.dataset.maskaReversed)), a.dataset.maskaTokensReplace != null && (e.tokensReplace = M(a.dataset.maskaTokensReplace)), a.dataset.maskaTokens != null && (e.tokens = C(a.dataset.maskaTokens)), e;
}, M = (a) => a !== "" ? !!JSON.parse(a) : !0, j = (a) => a.startsWith("[") && a.endsWith("]") ? T(a) : a, C = (a) => {
  if (a.startsWith("{") && a.endsWith("}"))
    return T(a);
  const t = {};
  return a.split("|").forEach((e) => {
    const s = e.split(":");
    t[s[0]] = {
      pattern: new RegExp(s[1]),
      optional: s[2] === "optional",
      multiple: s[2] === "multiple",
      repeated: s[2] === "repeated"
    };
  }), t;
};
class J {
  constructor(t, e = {}) {
    g(this, "items", /* @__PURE__ */ new Map()), g(this, "beforeinputEvent", (s) => {
      const n = s.target, i = this.items.get(n);
      i.isEager() && "inputType" in s && s.inputType.startsWith("delete") && i.unmasked(n.value).length <= 1 && this.setMaskedValue(n, "");
    }), g(this, "inputEvent", (s) => {
      if (s instanceof CustomEvent && s.type === "input" && s.detail != null && typeof s.detail == "object" && "masked" in s.detail)
        return;
      const n = s.target, i = this.items.get(n), o = n.value, p = n.selectionStart, h = n.selectionEnd;
      let m = o;
      if (i.isEager()) {
        const l = i.masked(o), c = i.unmasked(o);
        c === "" && "data" in s && s.data != null ? m = s.data : c !== i.unmasked(l) && (m = c);
      }
      if (this.setMaskedValue(n, m), "inputType" in s && (s.inputType.startsWith("delete") || p != null && p < o.length))
        try {
          n.setSelectionRange(p, h);
        } catch {
        }
    }), this.options = e, typeof t == "string" ? this.init(
      Array.from(document.querySelectorAll(t)),
      this.getMaskOpts(e)
    ) : this.init(
      "length" in t ? Array.from(t) : [t],
      this.getMaskOpts(e)
    );
  }
  destroy() {
    for (const t of this.items.keys())
      t.removeEventListener("input", this.inputEvent), t.removeEventListener("beforeinput", this.beforeinputEvent);
    this.items.clear();
  }
  needUpdateOptions(t, e) {
    const s = this.items.get(t), n = new w(O(t, this.getMaskOpts(e)));
    return JSON.stringify(s.opts) !== JSON.stringify(n.opts);
  }
  needUpdateValue(t) {
    const e = t.dataset.maskaValue;
    return e == null && t.value !== "" || e != null && e !== t.value;
  }
  getMaskOpts(t) {
    const { onMaska: e, preProcess: s, postProcess: n, ...i } = t;
    return i;
  }
  init(t, e) {
    for (const s of t) {
      const n = new w(O(s, e));
      this.items.set(s, n), s.value !== "" && this.setMaskedValue(s, s.value), s.addEventListener("input", this.inputEvent), s.addEventListener("beforeinput", this.beforeinputEvent);
    }
  }
  setMaskedValue(t, e) {
    const s = this.items.get(t);
    this.options.preProcess != null && (e = this.options.preProcess(e));
    const n = s.masked(e), i = s.unmasked(s.isEager() ? n : e), o = s.completed(e), p = { masked: n, unmasked: i, completed: o };
    e = n, this.options.postProcess != null && (e = this.options.postProcess(e)), t.value = e, t.dataset.maskaValue = e, this.options.onMaska != null && (Array.isArray(this.options.onMaska) ? this.options.onMaska.forEach((h) => h(p)) : this.options.onMaska(p)), t.dispatchEvent(new CustomEvent("maska", { detail: p })), t.dispatchEvent(new CustomEvent("input", { detail: p }));
  }
}
const A = /* @__PURE__ */ new WeakMap(), N = (a) => {
  setTimeout(() => {
    var t;
    ((t = A.get(a)) == null ? void 0 : t.needUpdateValue(a)) === !0 && a.dispatchEvent(new CustomEvent("input"));
  });
}, U = (a, t) => {
  const e = a instanceof HTMLInputElement ? a : a.querySelector("input"), s = { ...t.arg };
  if (e == null || (e == null ? void 0 : e.type) === "file")
    return;
  N(e);
  const n = A.get(e);
  if (n != null) {
    if (!n.needUpdateOptions(e, s))
      return;
    n.destroy();
  }
  if (t.value != null) {
    const i = t.value, o = (p) => {
      i.masked = p.masked, i.unmasked = p.unmasked, i.completed = p.completed;
    };
    s.onMaska = s.onMaska == null ? o : Array.isArray(s.onMaska) ? [...s.onMaska, o] : [s.onMaska, o];
  }
  A.set(e, new J(e, s));
};
export {
  U
};
